/*
 *
 *
 *
 */
#ifndef __REG_H__
#define __REG_H__

void setregrgp(unsigned int reg, unsigned int rgp, unsigned short val);
unsigned short *getregptr_rgp(unsigned int reg, unsigned int rgp);
int setmmapreg(unsigned int regaddr, unsigned short val);
unsigned short getmmapreg(unsigned int regaddr);
void dump_alu(void);
void dump_mac(void);
void dump_shifter(void);
void dump_dags(void);
int setnondataregrgp(unsigned int reg, unsigned int rgp, unsigned short val);
void regmove(unsigned int destreg, unsigned int destrgp, unsigned int srcreg, unsigned int srcrgp);
unsigned int getnondataregrgp(unsigned int reg, unsigned int rgp);
int setdagregrgp(unsigned int reg, unsigned int rgp, unsigned short val);
short14 *getdagregrgp_ptr(unsigned int reg, unsigned int rgp);

void set_mstat(unsigned int new);
unsigned int get_mstat(void);
void set_sstat(unsigned int new);
unsigned int get_sstat(void);
void set_astat(unsigned int new);
unsigned int get_astat(void);
void set_astatbit(unsigned int new);
void set_astatclearbit(unsigned int new);
void set_mstatbit(unsigned int bit);
void set_mstatclearbit(unsigned int bit);

void reg_flipset(int val);
int testcond(unsigned int cond);
int testtermcond(unsigned int cond);
#endif /* __REG_H__ */
